/***************************************************************************
 *   Copyright (C) 2006 by Michael Andreen                                 *
 *   andreen@student.chalmers.se                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

#ifndef __MISC_H__
#define __MISC_H__

/**
 * The type we use for genes, has to be a signed integer type.
 */
typedef int Gene;

/**
 * Simple struct for components. Holds the indexes, the first and last genes
 * + information if the component is unoriented.
 */
struct Component{
	Component(int b = 0,int e = 0,int s = 0,size_t i1 = 0, size_t i2 = 0):begin(b),end(e),sign(s),i1(i1), i2(i2){}
	bool operator==(const Component& c){
		return begin == c.begin && end == c.end && sign == c.sign && i1 == c.i1 && i2 == c.i2;
	}
	int begin;
	int end;
	int sign;
	size_t i1;
	size_t i2;
};

#endif
