/***************************************************************************
 *   Copyright (C) 2006 by Michael Andreen                                 *
 *   andreen@student.chalmers.se                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA          *
 ***************************************************************************/

#include "models.h"
#include "reverseaction.h"
#include "geneorder.h"

using namespace std;

namespace Models{

ModelImpl::~ModelImpl(){}

double ModelImpl::score(const SortAction& sa, const GeneOrder& go){
	return 1;
}
const char* ModelImpl::name(){
	return "Standard";
}


double Whirl::score(const SortAction& sa, const GeneOrder& go){
	const ReverseAction* ra = dynamic_cast<const ReverseAction*>(&sa.impl());

	if (ra){
		return 1;
	}
	return -1;
}
const char* Whirl::name(){
	return "Whirl";
}

double X::score(const SortAction& sa, const GeneOrder& go){
	const ReverseAction* ra = dynamic_cast<const ReverseAction*>(&sa.impl());

	if (ra){
		int l1 = go.size()/2 - ra->i();
		int l2 = ra->j() - go.size()/2;
		double C = abs(l1 - l2)/static_cast<double>(go.size());
		return 1/(C+1);
	}
	return -1;
}
const char* X::name(){
	return "X";
}

double Zipper::score(const SortAction& sa, const GeneOrder& go){
	const ReverseAction* ra = dynamic_cast<const ReverseAction*>(&sa.impl());

	if (ra){
		return 1.0/(((ra->j()-ra->i())/static_cast<double>(go.size()))+1.0);
	}
	return -1;
}
const char* Zipper::name(){
	return "Zipper";
}

double Cloud::score(const SortAction& sa, const GeneOrder& go){
	return 1;
}
const char* Cloud::name(){
	return "Cloud";
}

double FatX::score(const SortAction& sa, const GeneOrder& go){
	return 1;
}
const char* FatX::name(){
	return "FatX";
}

}
